// Copyright (c) Interactive Scientific LTD. All rights reserved.
// Licensed under the GPL. See License.txt in the project root for license information.
using System;
using System.Collections.Generic;
using System.Xml;

namespace Nano.Loading
{
    /// <summary>
    /// Loadable Interface.
    /// </summary>
    /// <autogeneratedoc />
    public interface ILoadable
    {
        /// <summary>
        /// Saves this instance to the specified element.
        /// </summary>
        /// <param name="context">The context.</param>
        /// <param name="element">The element.</param>
        /// <returns>XmlElement.</returns>
        XmlElement Save(LoadContext context, XmlElement element);

        /// <summary>
        /// Loads this instance from the specified node.
        /// </summary>
        /// <param name="context">The context.</param>
        /// <param name="node">The node.</param>
        void Load(LoadContext context, XmlNode node);
    }

    /// <summary>
    /// Class Loader.
    /// </summary>
    /// <autogeneratedoc />
    public static class Loader
    {
        /// <summary>
        /// Gets the name of the XML tag.
        /// </summary>
        /// <param name="original">The original.</param>
        /// <returns>System.String.</returns>
        /// <autogeneratedoc />
        public static string XmlTagName(string original)
        {
            string name = original;

            name = name.Replace(" ", "").Replace("\n", "").Replace("\r", "").Replace("\t", "");

            return name;
        }

        /// <summary>
        /// Saves the object.
        /// </summary>
        /// <param name="context">The context.</param>
        /// <param name="root">The root.</param>
        /// <param name="obj">The object.</param>
        /// <param name="tag">The tag.</param>
        /// <returns>XmlElement.</returns>
        /// <exception cref="System.Exception">Object is not loadable</exception>
        public static XmlElement SaveObject(LoadContext context, XmlNode root, object obj, string tag = null)
        {
            if (obj is ILoadable)
            {
                ILoadable loadable = obj as ILoadable;

                string name = LoadManager.GetXmlName(obj.GetType());

                XmlElement element;
                XmlDocument doc = root.OwnerDocument;

                if (root is XmlDocument)
                {
                    doc = (XmlDocument)root;
                }

                if (Helper.IsNotNullOrEmpty(tag))
                {
                    element = doc.CreateElement(tag);

                    element.Attributes.Append(doc.CreateAttribute("Type"));
                    element.Attributes["Type"].Value = name;
                }
                else
                {
                    element = doc.CreateElement(XmlTagName(name));
                }

                return loadable.Save(context, element);
            }
            else
            {
                throw new Exception("Object is not loadable");
            }
        }

        /// <summary>
        /// Saves the objects.
        /// </summary>
        /// <param name="context">The context.</param>
        /// <param name="root">The root.</param>
        /// <param name="objs">The objects.</param>
        /// <param name="collectionName">Name of the collection.</param>
        /// <param name="tag">The tag.</param>
        /// <returns>XmlElement.</returns>
        public static XmlElement SaveObjects(LoadContext context, XmlNode root, object[] objs, string collectionName = null, string tag = null)
        {
            XmlElement element;

            if (Helper.IsNotNullOrEmpty(collectionName))
            {
                XmlDocument doc = root.OwnerDocument;

                if (root is XmlDocument)
                {
                    doc = (XmlDocument)root;
                }

                element = doc.CreateElement(collectionName);
            }
            else
            {
                element = root as XmlElement;
            }

            foreach (object obj in objs)
            {
                element.AppendChild(SaveObject(context, element, obj, tag));
            }

            return element;
        }

        /// <summary>
        /// Saves the objects.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="root">The root.</param>
        /// <param name="objs">The objs.</param>
        /// <param name="collectionName">Name of the collection.</param>
        /// <param name="tag">The tag.</param>
        /// <returns>XmlElement.</returns>
        /// <autogeneratedoc />
        public static XmlElement SaveObjects<T>(LoadContext context, XmlNode root, IEnumerable<T> objs, string collectionName = null, string tag = null) where T : ILoadable
        {
            XmlElement element;

            if (Helper.IsNotNullOrEmpty(collectionName))
            {
                XmlDocument doc = root.OwnerDocument;

                if (root is XmlDocument)
                {
                    doc = (XmlDocument)root;
                }

                element = doc.CreateElement(collectionName);
            }
            else
            {
                element = root as XmlElement;
            }

            foreach (object obj in objs)
            {
                element.AppendChild(SaveObject(context, element, obj, tag));
            }

            return element;
        }

        /// <summary>
        /// Loads the object.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="sourceNode">The source node.</param>
        /// <returns>T.</returns>
        public static T LoadObject<T>(LoadContext context, XmlNode sourceNode) where T : ILoadable
        {
            T[] loaded = LoadObjects<T>(context, null, sourceNode);

            if (loaded.Length == 0)
            {
                return default(T);
            }
            else
            {
                return loaded[0];
            }
        }

        /// <summary>
        /// Loads the object that is the root node.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context"></param>
        /// <param name="rootNode"></param>
        /// <returns></returns>
        public static T LoadRootObject<T>(LoadContext context, XmlNode rootNode) where T : ILoadable
        {
            return LoadRootObject<T>(context, null, rootNode, new Type[0], new object[0]);
        }

        public static T LoadRootObject<T>(LoadContext context, XmlNode rootNode, Type[] argTypes, object[] arguments)
            where T : ILoadable
        {
            return LoadRootObject<T>(context, null, rootNode, argTypes, arguments);
        }

        public static T LoadRootObject<T>(LoadContext context, string tag, XmlNode rootNode, Type[] argTypes,
            object[] arguments) where T : ILoadable
        {
            Type baseType = typeof(T);

            Dictionary<string, Type> types = LoadManager.GetTypeOfType(baseType);

            if (rootNode == null)
                return default(T);

            if ((tag == null) || (tag.Length < 1))
            {
                string typeName = rootNode.Name;

                if (types.ContainsKey(typeName))
                {
                    Type type = types[typeName];

                    T obj;
                    try
                    {
                        obj = (T)type.GetConstructor(argTypes).Invoke(arguments);
                    }
                    catch (Exception e)
                    {
                        string message = $"Exception thrown constructing object of type {typeName}. Does a valid constructor exist?";
                        context.Error(message);
                        throw new Exception(message, e);
                    }

                    obj.Load(context, rootNode);
                    return obj;
                }
            }
            else
            {
                //Allow case insensitivity for attribute "Type".
                XmlAttribute typeAttribute = rootNode.Attributes["Type"] ?? rootNode.Attributes["type"];

                if (typeAttribute == null)
                {
                    return default(T);
                }

                string typeName = typeAttribute.Value;

                if (types.ContainsKey(typeName) == false)
                {
                    return default(T);
                }

                Type type = types[typeName];

                T obj = (T)type.GetConstructor(argTypes).Invoke(arguments);

                obj.Load(context, rootNode);

                return obj;
            }

            return default(T);
        }

        /// <summary>
        /// Loads the object.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="tag">The tag.</param>
        /// <param name="sourceNode">The source node.</param>
        /// <returns>T.</returns>
        public static T LoadObject<T>(LoadContext context, string tag, XmlNode sourceNode) where T : ILoadable
        {
            T[] loaded = LoadObjects<T>(context, tag, sourceNode);

            if (loaded.Length == 0)
            {
                return default(T);
            }
            else
            {
                return loaded[0];
            }
        }

        /// <summary>
        /// Loads the object.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="sourceNode">The source node.</param>
        /// <param name="argTypes">The argument types.</param>
        /// <param name="arguments">The arguments.</param>
        /// <returns>T.</returns>
        public static T LoadObject<T>(LoadContext context, XmlNode sourceNode, Type[] argTypes, object[] arguments) where T : ILoadable
        {
            T[] loaded = LoadObjects<T>(context, null, sourceNode, argTypes, arguments);

            if (loaded.Length == 0)
            {
                return default(T);
            }
            else
            {
                return loaded[0];
            }
        }

        /// <summary>
        /// Loads the object.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="tag">The tag.</param>
        /// <param name="sourceNode">The source node.</param>
        /// <param name="argTypes">The argument types.</param>
        /// <param name="arguments">The arguments.</param>
        /// <returns>T.</returns>
        public static T LoadObject<T>(LoadContext context, string tag, XmlNode sourceNode, Type[] argTypes, object[] arguments) where T : ILoadable
        {
            T[] loaded = LoadObjects<T>(context, tag, sourceNode, argTypes, arguments);

            if (loaded.Length == 0)
            {
                return default(T);
            }
            else
            {
                return loaded[0];
            }
        }

        /// <summary>
        /// Loads the objects.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="sourceNode">The source node.</param>
        /// <returns>T[].</returns>
        public static T[] LoadObjects<T>(LoadContext context, XmlNode sourceNode) where T : ILoadable
        {
            return LoadObjects<T>(context, null, sourceNode, new Type[0], new object[0]);
        }

        /// <summary>
        /// Loads the objects.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="tag">The tag.</param>
        /// <param name="sourceNode">The source node.</param>
        /// <returns>T[].</returns>
        public static T[] LoadObjects<T>(LoadContext context, string tag, XmlNode sourceNode) where T : ILoadable
        {
            return LoadObjects<T>(context, tag, sourceNode, new Type[0], new object[0]);
        }

        /// <summary>
        /// Loads the objects.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="sourceNode">The source node.</param>
        /// <param name="argTypes">The argument types.</param>
        /// <param name="arguments">The arguments.</param>
        /// <returns>T[].</returns>
        public static T[] LoadObjects<T>(LoadContext context, XmlNode sourceNode, Type[] argTypes, object[] arguments) where T : ILoadable
        {
            return LoadObjects<T>(context, null, sourceNode, argTypes, arguments);
        }

        /// <summary>
        /// Loads the objects.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="context">The context.</param>
        /// <param name="tag">The tag.</param>
        /// <param name="sourceNode">The source node.</param>
        /// <param name="argTypes">The argument types.</param>
        /// <param name="arguments">The arguments.</param>
        /// <returns>T[].</returns>
        public static T[] LoadObjects<T>(LoadContext context, string tag, XmlNode sourceNode, Type[] argTypes, object[] arguments) where T : ILoadable
        {
            Type baseType = typeof(T);

            if (sourceNode == null)
            {
                return new T[0];
            }

            Dictionary<string, Type> types = LoadManager.GetTypeOfType(baseType);
            List<T> objects = new List<T>();

            if ((tag == null) || (tag.Length < 1))
            {
                foreach (XmlNode node in sourceNode.ChildNodes)
                {
                    string typeName = node.Name;

                    if (types.ContainsKey(typeName))
                    {
                        Type type = types[typeName];

                        T obj;
                        try
                        {
                            obj = (T)type.GetConstructor(argTypes).Invoke(arguments);
                        }
                        catch (Exception e)
                        {
                            string message = $"Exception thrown constructing object of type {typeName}. Does a valid constructor exist?";
                            context.Error(message);
                            throw new Exception(message, e);
                        }

                        obj.Load(context, node);
                        objects.Add(obj);
                    }
                }
            }
            else
            {
                XmlNodeList nodes = sourceNode.SelectNodes(tag);

                foreach (XmlNode node in nodes)
                {
                    //Allow case insensitivity for attribute "Type".
                    XmlAttribute typeAttribute = node.Attributes["Type"] ?? node.Attributes["type"];

                    if (typeAttribute == null)
                    {
                        continue;
                    }

                    string typeName = typeAttribute.Value;

                    if (types.ContainsKey(typeName) == false)
                    {
                        continue;
                    }

                    Type type = types[typeName];

                    T obj = (T)type.GetConstructor(argTypes).Invoke(arguments);

                    obj.Load(context, node);
                    objects.Add(obj);
                }
            }

            return objects.ToArray();
        }
    }
}